package dev.xoy.xoyshowoff.items;

import dev.xoy.xoyshowoff.XoyShowOff;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.FallingBlock;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityShootBowEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;
import org.bukkit.util.Vector;

public class SandGunListener implements Listener {
    private ItemStack inventoryContainsItemStackWithKey(Player player, NamespacedKey key) {
        PlayerInventory inventory = player.getInventory();
        for(ItemStack stack : inventory.getContents()) {
            if(stack != null && stack.getItemMeta() != null &&
                    stack.getItemMeta().getPersistentDataContainer().has(key)) return stack;
        }
        return null;
    }

    public FallingBlock spawnSandEntityWithVelocity(Location location, Vector velocity) {
        FallingBlock sand = (FallingBlock) location.getWorld().spawnEntity(location, EntityType.FALLING_BLOCK);
        sand.setBlockData(Material.SAND.createBlockData());
        sand.setVelocity(velocity);

        return sand;
    }

    @EventHandler
    public void onEntityShootBow(EntityShootBowEvent event) {
        XoyShowOff.LOGGER.info("onEntityShootBow");
        if(event.getEntity() instanceof Player) {
            Player player = (Player) event.getEntity();
            ItemStack bow = event.getBow();
            if(bow != null && bow.getItemMeta() != null && bow.getItemMeta().getPersistentDataContainer().has(Keys.SANDGUN)) {
                XoyShowOff.LOGGER.info("isSandGun");
                ItemStack ammo = inventoryContainsItemStackWithKey(player, Keys.SANDARROW);
                if(ammo != null) {
                    //ammo.setAmount(ammo.getAmount() - 1);
                    Vector velocity = player.getEyeLocation().getDirection();
                    FallingBlock sand = spawnSandEntityWithVelocity(player.getEyeLocation(), velocity);
                    XoyShowOff.LOGGER.info("Spawned: " + sand.getName());
                }
                event.setCancelled(true);
            }
        }
    }
}
